#include "CFConsole.H"
#include <stdarg.h>

#include "Logger.H"
extern Logger logger;

CFConsole::CFConsole(int wdth, int hght,bool brdr, bool shdw):
		Window(wdth,hght,brdr,shdw),
		_lcount(0) {
	_rebld=true;
	_wtitle="Curfloo Console";
	_consol=new TextArea(wdth-4,hght-2,256);
	(*_consol).style(_stile);
	Window::add("Console",_consol,2,1);
}

CFConsole::~CFConsole() {
	delete (_consol);
}

widstat CFConsole::input(Char inp) {
	return (*_consol).input(inp);
}

widstat CFConsole::style(Char stile) {
	_stile=stile;
	_tstile=stile;
	if (_tstile.isBold())
		_tstile.tBold();
	_tstile.setFore(cc_black);
	(*_consol).style(_tstile);
	_rebld=true;
	return (ws_accepted);
}

int CFConsole::log(const char *txt, ...) {
	string
		str;
	va_list
		var;
	char
		buf[1024];
	
	va_start(var,txt);
	vsnprintf(buf,sizeof(buf),txt,var);
	va_end(var);
	str=buf;
	return (log(str));
}

int CFConsole::log(const string &str) {
	Text
		txt;
	string
		line;
	char
		lc[16];
	
	sprintf(lc,"%03d: ",((++_lcount)>999)?_lcount=0:_lcount);
	line=lc;
	line+=str;
	txt.style(_tstile);
	txt.setText(line);
	(*_consol)+=txt;
	_rebld=true;
	return 0;
}
